;---------------------------------------------------------;
;             Written by: Muazzam Ali Kazmi		  ;
;                     Public domain                       ;
;---------------------------------------------------------;

;________________________________________________
;Put bitmap character in graphics mode
;IN:  dl Column
;     dh Row
;     al Character
;OUT: nothing
;
graphics.putBitmapChar:
	
	push edx
	
	and eax, 0xff
	sub eax, 32
	mov ebx, fonts.height
	mul ebx
	
	mov esi, fonts
	add esi, eax
	
	pop edx
	push edx
	
	mov eax, fonts.width
	movzx ebx, dl
	mul ebx
	mov word[.x], ax
	mov word[.initialX], ax
	
	pop edx
	
	mov eax, fonts.height
	movzx ebx, dh
	mul ebx
	mov word[.y], ax
	
	mov ecx, fonts.height
	
	dec word[.y]
.putColumn:

	inc word[.y]
	
	mov ax, word[.initialX]
	mov word[.x], ax

	lodsb
		
	push ecx
	mov ecx, fonts.width
.putRow:
	bt ax, 7
	jc .putForeground
	
.putBackground:
	push eax
	mov edx, dword[text.background]
	
	movzx eax, word[.x]
	movzx ebx, word[.y]	
	inc word[.x]
	
	call graphicsPutPixel
	
	pop eax
	jmp .putRow.next
	
.putForeground:
	push eax
	mov edx, dword[text.foreground]
	
	movzx eax, word[.x]
	movzx ebx, word[.y]	
	inc word[.x]
	
	call graphicsPutPixel
	
	pop eax
	
.putRow.next:	
	shl al, 1
	loop .putRow
	
	pop ecx
	loop .putColumn
	
.end:
	ret
	
.x:	dw 0
.y:	dw 0
.initialX: dw 0
